program FIND; {fuer diebox}
(****************************************************************************)
(* FIND.PAS Version : 1.2                                                   *)
(* DIEBOX RUN-Utility, FIND zeigt alle Lauffaehigen Programme in dem Ordner *)
(* an in dem sich FIND befindet. (*.EXE und *.COM) Ein ndern des Pfades ist*)
(* per Remote nicht mglich. Die Texte in FIND.CFG werden vor               *)
(* bzw hinter den gefundenen Programmen ausgegeben                          *)
(* Neu in 1.2 : Mit NOP=NAME.EXE in der CFG-Datei koennen Programmnamen vom *)
(* Auflisten ausgeschlossen werden.                                         *)
(* Geschrieben von : Roger Luff                                             *)
(*                   Birkenweg 89a                                          *)
(*                   D-22885 Barsbttel                                     *)
(*                   DG2HL @ DB0HB                                          *)
(*                                                                          *)
(*         Weitergabe nur in der unvernderten Version !!!!!!!              *)
(*            Verbesserungsvorschlge bitte an mich !!!!!!!                 *)
(****************************************************************************)


uses dos;

type
  str90   = string[90];
  str40   = string[40];
  str3    = string[3];
  str1    = string[1];
  zeiger  = ^ZeigerInhalt;
  ZeigerInhalt = record
                   dat    : str40;
                   fastp  : byte;
                   links  : zeiger;
                   rechts : zeiger;
                 end;
var
  count     : word;
  noco      : word;
  n1        : zeiger;
  n2        : zeiger;
  nowu      : zeiger;
  p1        : zeiger;
  p2        : zeiger;
  wurzel    : zeiger;
  homepfad  : pathstr;
  n         : namestr;
  e         : extstr;
  FileExist : boolean;
  textdat   : text;

function upcasestr (Zeile : str90) : Str90;
var
  i,ch : byte;

BEGIN
  FOR i := 1 TO Length(Zeile) DO
  begin
    ch := ord(zeile[i]);
    case ch of
      97..122 : zeile[i] := char(ch-32);
      129     : zeile[i] := char(154);
      132     : zeile[i] := char(142);
      148     : zeile[i] := char(153);
    END;
  END;
  UpcaseStr := Zeile;
END;

procedure killpointer(var count : word;var p1,p2,wurzel : zeiger);
var
  a : word;
begin
  if (count > 0) then
  begin
    p1 := wurzel;
    for a := 1 to count do
    begin
      p2 := p1^.rechts;
      dispose(p1);
      p1 := p2;
    end;
  end;
  count := 0;
end;

function testin(noco : word;n1,n2,nowu : zeiger;teststr : str40) : boolean;
var
  a : word;
begin
  testin := true;
  if (noco > 0) then
  begin
    n1 := nowu;
    for a := 1 to noco do
    begin
      n2 := n1^.rechts;
      if (teststr = n1^.dat) then
        testin := false;
      n1 := n2;
    end;
  end;
end;

procedure ReEin(var p1,p2 : zeiger);
begin
  p2^.links:=p1; {Linker Zeiger von p2 auf p1}
  p1^.rechts:=p2; {Rechter Zeiger von p1 auf p2}
  p2^.rechts:=NIL;
end;

procedure LiEin(var p1,p2,wurzel : zeiger);
begin
  p1^.links := p2;
  p2^.rechts := p1;
  p2^.links := NIL;
  wurzel := p2;
end;

procedure MiEin(var p1,p2 : Zeiger);
begin
  p2^.rechts := p1^.rechts;
  p2^.links  := p1;
  p1^.rechts := p2;
  p1 := p2^.rechts;
  p1^.links := p2;
end;

procedure leseEin(var p1,p2,wurzel : zeiger;Zeile : str40;Fpos : byte;Sort : boolean;
                  Lmin,Laeng : byte; var count : word);
{Zeile     = neuer Eintrag in die Pointerkette}
{FPos      = Positon des Fastkeys}
{Sort      = True wenn sortiert werden soll}
{LaengeMin = Anfang des Suchstrings in Zeile Position berechnet mit :}
{length(zeile)-LMin}
{Laeng     = Lnge des Suchstrings ab der Postion LaengeMin }
{            soll der gesammte String ausgewertet werden, so ist Lmin=Laeng=length(Zeile) gestetzt werden.
{Count     = muss vor erstem Aufruf auf 0 gesetzt werden}

var
  sneu  : string;
  salt  : string;
  Pos   : word;
  ready : boolean;

begin
  sneu := copy(Zeile,length(Zeile)-Lmin,Laeng);
  if (count = 0) then
  begin
    inc(count);
    new(p1);
    wurzel:=p1;
    p1^.links  := NIL;
    p1^.rechts := NIL;
    p1^.dat    := Zeile;
    p1^.FastP  := FPos;
  end else
  begin
    if (sort) then
    begin
      p1 := wurzel;
      salt := copy(p1^.dat,length(p1^.dat)-Lmin,Laeng);
      pos := 1;
      while (pos < count) and (salt < sneu) do
      begin
        p2 := p1^.rechts;
        salt := copy(p2^.dat,length(p2^.dat)-Lmin,Laeng);
        if (salt < sneu) then
          p1 := p2;
        inc (pos);
      end;
      new(p2); {neues Element erzeugen}
      p2^.dat := Zeile;
      p2^.FastP := Fpos;
      ready := false;
      if (pos=1) and (salt > sneu) then {vor wurzel}
      begin
        LiEin(p1,p2,wurzel);
        ready := true;
      end;
      if (pos=count) and (salt < sneu) then {ganz hinten dran}
      begin
        ReEin(p1,p2);
        ready := true;
      end;
      if (not ready) then
        MiEin(p1,p2);
    end else
    begin
      p1 := wurzel;
      for pos := 1 to count-1 do
        p1 := p1^.rechts;
      new(p2); {neues Element erzeugen}
      p2^.dat := Zeile;
      p2^.FastP := Fpos;
      ReEin(p1,p2);
    end;
    inc(count);
  end;
end;

procedure dateisuche(var p1,p2,wurzel,n1,n2,nowu:zeiger;Lmin,Laeng : byte; endung:str3;var pfad : Pathstr;
                     var count : word);
var
  fileinfo : searchrec;
  suche    : pathstr;
  dummy    : str40;
  ppos     : byte;

begin;
  suche := concat(pfad,'*.',endung);
  FindFirst(suche, AnyFile, FileInfo);
  while (DosError = 0) do
  begin
    if (fileinfo.name <> '.') and (fileinfo.attr <> VolumeID) and (fileinfo.attr <> directory) then
    begin
      ppos := pos('.',fileinfo.name)-1;
      dummy := copy(fileinfo.name,1,ppos);
    end;
    if (testin(noco,n1,n2,nowu,dummy)) then
      leseein(p1,p2,wurzel,dummy,0,true,LMin,Laeng,count);
    FindNext(FileInfo);
  end;
end;

procedure oeffnedat(var textdat : text; var FileExist : boolean);
begin
  assign(textdat,homepfad+'find.cfg');
  {$I-}
  reset(textdat);
  {$I+}
  FileExist := (IOResult = 0);
end;

procedure readdat(var textdat : text;nr:str1;var n1,n2,nowu : zeiger;var noco:word);
var
  line   : str90;
  ppos   : byte;
begin
  while (not eof(textdat)) do
  begin
    readln(textdat,line);
    if (copy(line,1,1) <> '#') then
    begin
      if (copy(line,1,4) = concat('TX',nr,'=')) then
        writeln(copy(line,5,length(line)-4));
      if (copy(line,1,4)=concat('NOP=')) and (nr = '1') then
      begin
        line := copy(line,5,length(line)-4);
        line := upcasestr(line);
        if (line <> '') then
          ppos := pos('.',line)-1;
          if (ppos > 0) then
            line := copy(line,1,ppos);
          leseein(n1,n2,nowu,line,0,true,8,8,noco);
      end;
    end;
  end;
end;

procedure Ausgabe(var p1,p2,wurzel : zeiger; count : word);
var
  a,b : word;
  leer      : byte;

begin
  p1 := wurzel;
  b := 0;
  for a := 1 to count do
  begin
    inc(b);
    write(p1^.dat);
    for leer := 1 to 10-length(p1^.dat) do
      write(' ');
    if (b = 7) then
    begin
      writeln;
      b := 0;
    end;
    p1 := p1^.rechts;
  end;
  if (b <> 0) then
    writeln;
end;

function testme : boolean;
var
  a : byte;
  dummy : str90;
begin
  testme := false;
  for a := 1 to paramcount do
  begin
    dummy := upcasestr(paramstr(a));
    if (pos('DG2HL',dummy) <> 0) then
      testme := true;
  end;
end;

begin
  writeln;
  writeln('RUNPROGRAMM-FIND V 1.2    11.1993 DG2HL   R.Luff');
  writeln;
  count := 0;
  noco  := 0;
  homepfad := paramstr(0);
  fsplit(homepfad,homepfad,n,e);
  oeffnedat(textdat,FileExist);
  if (FileExist) then
  begin
    readdat(textdat,'1',n1,n2,nowu,noco);
    reset(textdat);
  end;
  if ((testme) and (noco > 0)) then
  begin
    Ausgabe(n1,n2,nowu,noco);
    writeln;
  end;
  dateisuche(p1,p2,wurzel,n1,n2,nowu,8,8,'EXE',homepfad,count);
  dateisuche(p1,p2,wurzel,n1,n2,nowu,8,8,'COM',homepfad,count);
  Ausgabe(p1,p2,wurzel,count);
  if (FileExist) then
  begin
    readdat(textdat,'2',n1,n2,nowu,noco);
    close(textdat);
  end;
  killpointer(count,p1,p2,wurzel);
  killpointer(noco,n1,n2,nowu);
end.
